<script lang="ts" setup>
import type { Booking, Room } from '@/entities';
import { useBookingStore } from '@/stores/booking';
import { useRoomStore } from '@/stores/room';
import type { Dayjs } from 'dayjs';
import { storeToRefs } from 'pinia';
import { computed, onBeforeMount, onMounted, onUnmounted, ref, toRef, type Ref } from 'vue';
import RoomBlockComponent from './RoomBlockComponent.vue';

interface DayBookings {
  am: {date: Dayjs, bookings:Booking[]}[];
  pm: {date: Dayjs, bookings:Booking[]}[];
}

const props = defineProps<{
  day: Dayjs

}>();

const day = toRef(props, 'day');

const storeRoom = useRoomStore();
const { rooms } = storeToRefs(storeRoom);

const storeBooking = useBookingStore();
const { bookings } = storeToRefs(storeBooking)

const emitWeek = defineEmits({
  changeWeek(days: number) { return true },
  dateSelect(booking: Booking) { return true }
})

const scrollComponent = ref(true);




const bookingsForDay = computed(() => {
  console.log('foddays')
  const dayBooking:DayBookings = {am:[], pm:[]};
  const endHours = [12, 17];
  for (const endHour of endHours) {
    for (let i = 1; i <= 5; i++) {
      const date = day.value.day(i);
      const filtered = bookings.value.filter(item => date.hour(endHour).isBefore(item.endDate) && date.hour(endHour).isAfter(item.startDate));
      for (const room of rooms.value) {
        if (!filtered.find(item => item.room?.id == room.id)) {
          filtered.push({ room, startDate: date.toDate(), endDate: date.hour(endHour).toDate() })
        }
      }
      if(endHour == 12) {
        dayBooking.am.push({date, bookings: filtered});
      } else {
        dayBooking.pm.push({date, bookings: filtered});

      }
    }
  }
  return dayBooking;
});

onMounted(() => {
  window.addEventListener("touchmove", handleScroll);
})

onUnmounted(() => { window.removeEventListener("touchmove", handleScroll) })

/** 
 *  fonction permet de passer d'une semaine à l'autre au scroll sur mobile
 */
function handleScroll(e: any) {
  console.log(e.layerX);
  console.log(window.outerWidth)
  const value = e.layerX

  if (value === 0 && !scrollComponent.value) {
    scrollComponent.value = true;
    previousWeek()
  }

  if (value === window.outerWidth) {
    scrollComponent.value = true;
    nextWeek()
  }
  setTimeout(() => scrollComponent.value = false, 2000);
}

function nextWeek() {
  emitWeek('changeWeek', 7);
}

function previousWeek() {
  emitWeek('changeWeek', -7);

}

function handleSelect(booking: Booking) {
  emitWeek('dateSelect', booking);
}

</script>


<template >



  <el-row class="row-bg" justify="space-around">
    <el-icon class="icon icon-left" :size="40" color="#ce0033" @click="previousWeek">
      <ArrowLeft />
    </el-icon>


    <el-icon class="icon icon-right" :size="40" color="#ce0033" @click="nextWeek">
      <ArrowRight />
    </el-icon>
  </el-row>


  <main>



    <el-descriptions :column="5" border direction="vertical">
      <el-descriptions-item v-for="item of bookingsForDay.am" :label="item.date.format('dddd DD/MM') + ' Matin'">
        <RoomBlockComponent :bookings="item.bookings" @room-click="handleSelect($event)" />
      </el-descriptions-item>
    </el-descriptions>


    <el-descriptions :column="5" border direction="vertical">
      <el-descriptions-item v-for="item of bookingsForDay.pm" :label="item.date.format('dddd DD/MM') + ' Après midi'">
        <RoomBlockComponent :bookings="item.bookings" @room-click="handleSelect($event)" />
      </el-descriptions-item>
    </el-descriptions>



  </main>



</template>

<style scoped>
.icon {
  cursor: pointer;
  opacity: 0.2;
  transition-property: opacity;
  transition-duration: 2s;
}

.icon:hover {
  opacity: 1;
}

@media screen and (max-width: 1280px) {
  main {
    width: 1280px;
  }

  .icon-left {
    left: 10vw;
  }

  .icon-right {
    left: 70vw;
  }

}
</style>